﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Diagnostics;

namespace IPSToolLibrary
{
    class PerformanceUtils
    {
        PerformanceCounter cpuCounter;
        PerformanceCounter ramCounter;
        PerformanceCounter systemUpTime;

        public PerformanceUtils()
        {
            cpuCounter = new PerformanceCounter();
            cpuCounter.CategoryName = "Processor";
            cpuCounter.CounterName = "% Processor Time";
            cpuCounter.InstanceName = "_Total";

            ramCounter = new PerformanceCounter("Memory", "Available MBytes");

            systemUpTime = new PerformanceCounter("System", "System Up Time");
        }

        public string GetUsedCPU()
        {
            return cpuCounter.NextValue().ToString() + "%";
        }

        public string GetAvailableMemory()
        {
            return ramCounter.NextValue().ToString() + " MB";
        }

        public string SystemUpTime()
        {
            return systemUpTime.NextValue().ToString(); ;
        }

        public string getProcessMemory(string program)
        {
            foreach (Process process in Process.GetProcessesByName(program))
            {
                return process.WorkingSet64.ToString();
            };
            return "";
        }
    }
}
